Unit MaxAreas;

Interface

Const
  MaxClass = 12;
  MaxOvr = 16;
Type
  Override = Record
    Priv : Integer;
    Lock : Byte;
    Ch : Char;
  End;
  AreaRecordType = Record
    Id : Array[1..4] Of Char;
    StructLen : Word;
    AreaNo : Array[1..2] Of Char;
    Name : Array[1..40] Of Char;
    AreaType : Word;
    MsgPath : Array[1..80] Of Char;
    MsgName : Array[1..40] Of Char;
    MsgInfo, MsgBar : Array[1..80] Of Char;
    Origin : Array[1..62] Of Char;
    MsgPriv : Word;
    MsgLock, Fill1 : Byte;
    OriginAka : Word;
    FilePath, UpPath, FileBar, FilesBbs, FileInfo : Array[1..80] Of Char;
    FilePriv : Word;
    FileLock, Fill2 : Byte;
    MsgMenuName, FileMenuName : Array[1..13] Of Char;
    Attrib : Array[1..MaxClass] Of Word;
    Movr : Array[1..MaxOvr] Of Override;
    Fovr : Array[1..MaxOvr] Of Override;
  End;
Var
  AreaPath : String[80];
  StructLen : Word;

Procedure OpenMaximusArea;
Function GetMaximusArea(AreaNo, StructLen : LongInt; Var AreaRecord : AreaRecordType) : Byte;
Procedure CloseMaximusArea;

Implementation

Uses
  Crt, Dos;
Var
  DirInfo : SearchRec;
  AreaDat : File;
{========================================================================}
Procedure OpenMaximusArea;
  Begin
    FindFirst(AreaPath,Archive,DirInfo);
    If DosError <> 0 Then
    Begin
      WriteLn(AreaPath+' not found!');
      Halt(1);
    End
    Else
    Begin
      Assign(AreaDat,AreaPath);
      FileMode := 64;
      Reset(AreaDat,1);
      Seek(AreaDat,4);
      BlockRead(AreaDat,StructLen,SizeOf(StructLen));
    End;
  End;
{========================================================================}
Function GetMaximusArea(AreaNo, StructLen : LongInt; Var AreaRecord : AreaRecordType) : Byte;
  Begin
    If (StructLen*AreaNo) >= FileSize(AreaDat) Then
    Begin
      GetMaximusArea := 254;
    End
    Else
    Begin
      Seek(AreaDat,StructLen*(AreaNo-1));
      BlockRead(AreaDat,AreaRecord,SizeOf(AreaRecord));
      GetMaximusArea := 0;
    End;
  End;
{========================================================================}
Procedure CloseMaximusArea;
  Begin
    Close(AreaDat);
  End;
{========================================================================}
End.
